      Subroutine Calclt(ICurr,IStaCr,ExpR)

      Use ModXpr
      Implicit None
      Type(Expression),Dimension(NumExp)          :: ExpR

C     Internal arrays
      Integer IStaCr,ICurr,i,j,ICurOl,NmIdle
      Logical Contin
      Integer IType
      COMMON /Type/ IType
      Integer IPrint
      COMMON /Print/ IPrint

C      Write(6,*) 'MaxNum in Calclt= ',MaxNum

C     Now we have ICurr terms in 'R' arrays.  We need to order and 
C     simplify them
C     First organize the arrays in an order of OperR terms

      NmIdle = 0
C     Abandon cycle if NmIdle=2(3) transformation attempts in a row didn't
C     yield any result
      Do j=1,5
         If(ICurr.eq.0) Exit
         ICurOl = ICurr

C        Sum up terms differing by only 1 energy in denominator
         Call SumTrm(IStaCr,ICurr,ExpR)
         If(.not.Contin(ICurr,ICurOl,NmIdle)) Exit

C        Sum up similar terms 
         Call CanTrm(IStaCr,ICurr,ExpR)
C         If(.not.Contin(ICurr,ICurOl,NmIdle)) Exit

C        Cancel terms that produce delta functions
C         If(IType.ne.11) Cycle

C         Call ChgVa1(ICurr,IStaCr,ExpR,2)
C         If(.not.Contin(ICurr,ICurOl,NmIdle)) Exit
      End Do

      If(IPrint.ge.4) then
         Write(6,*)'Final terms after ChgVar'
         Write(6,*)'$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$' 
         Do i=IStaCr,ICurr
            Call Output(6,ExpR(i),' ',i)
            Write(6,*)'x'
         End Do
         Write(6,*)'$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$'
      End If

      Return
      End

