      Subroutine GenPer(IPer,MMin,MMax,NNum,IPerm)
C     Generates permutation IPerm whose number is IPer.
C      Input supplied by PreNum
C     On input NNum ... # of operators of each type
C              MMin,MMax
C     MMin(8),MMax(8) ... limits for searching permutation of
C                         NNum OperR terms
C     Example:
C     Min=(1,10,100,1,1,1,10,1)
C     Max=(1,99,999,1,1,1,99,1)


      Implicit None

      Logical Permut

C     Internal arrays
      Integer,Dimension(8) :: IPerm,MMin,MMax,NNum
      Integer i,j,k,l,m,n,mm,nn,ICount,IPer
      Integer IPrint
      COMMON /Print/ IPrint

      ICount=0
      Do i=Mmin(1),MMax(1)
         If(.not.Permut(i,NNum(1)).and.i.ne.1) Cycle
         IPerm(1)=i
         Do j=Mmin(2),MMax(2)
            If(.not.Permut(j,NNum(2)).and.j.ne.1) Cycle
            IPerm(2)=j
            Do k=Mmin(3),MMax(3)
               If(.not.Permut(k,NNum(3)).and.k.ne.1)
     $         Cycle
               IPerm(3)=k
               Do l=Mmin(4),MMax(4)
                  If(.not.Permut(l,NNum(4)).
     $            and.l.ne.1) Cycle
                  IPerm(4)=l
                  Do m=Mmin(5),MMax(5)
                     If(.not.Permut(m,NNum(5)).
     $               and.m.ne.1)Cycle
                     IPerm(5)=m
                     Do n=Mmin(6),MMax(6)
                        If(.not.Permut(n,NNum(6))
     $                  .and.n.ne.1) Cycle
                        IPerm(6)=n
                        Do nn=Mmin(7),MMax(7)
                           If(.not.Permut(nn,NNum(7)).
     $                     and.nn.ne.1)Cycle
                           IPerm(7)=nn
                           Do mm=Mmin(8),MMax(8)
                              If(.not.Permut(mm,NNum(8))
     $                        .and.mm.ne.1) Cycle
                              IPerm(8)=mm

                              ICount=ICount+1
                              If(ICount.eq.IPer) Return
                           End Do
                        End Do
                     End Do
                  End Do
               End Do
            End Do
         End Do
      End Do
      Write(6,*)'Warning!!! Permutation # ',IPer,' not found!'
      Return
      End
