      Subroutine MakStd(ExpR,Mode)

      Use ModXpr
      Implicit None
      Type(Expression)          :: ExpR

C     Internal arrays
      Type(Expression)          :: Exp2,ExpBst
      Integer,Dimension(8) :: IPerm,IPermB,MMin,MMax,NNum
      Integer i,NumTot
      Logical GrTh3
      Integer IType,Cyc,Mode,IPrOld
      COMMON /Type/ IType
      Integer IPrint
      COMMON /Print/ IPrint

C     This subroutine changes variables  so that first
C     LInd  momexps in OperR become d,f,g
C     LInd  is # of independent momenta in OperR.
C     Also arrange spinor indices in proper order.
C     Mode ... 0,1 tells what type of comparison to be used

C      If(ExpR%IPowr(8).eq.1) Return

      Call Standr(ExpR)
      If(IType.eq.4)   Return

      Call PreNum(ExpR%Oper,ExpR%UVE,MMin,MMax,IPermB,NNum,NumTot)

C     IPermB  ... initial (trivial) permutation
C     this array will hold the best permutation currently achieved

      If(IPrint.ge.9) Write(6,*)'MakStd:MMin=',MMin
      If(IPrint.ge.9) Write(6,*)'MakStd:MMax=',MMax

C     Try all permutations and find one that yields smaller ExpR

      IPrOld = IPrint
      IPrint = -1
      If(IPrint.ge.9) 
     $Call Output(6,ExpR,'MakStd:Before permutations',-1)
      ExpBst = ExpR

      Do i=1,NumTot

         Exp2 = ExpR
         Call PermAp(i,MMin,MMax,NNum,Exp2,Cyc,IPerm)
         If(Cyc.eq.1) Cycle
         If(IPrint.ge.9) Call Output(6,Exp2,'MakStd:After  PermAp',-1)

         If(Mode.eq.0.and.GrTh1(ExpBst,Exp2)
     $   .or.Mode.eq.1.and.GrTh3(ExpBst,Exp2)) then
            If(IPrint.ge.9) then
               Write(6,*)'This term is smaller than'
               Call Output(6,ExpBst,' ',-1)
               Write(6,*)'Update ExpBst'
            End If
            ExpBst = Exp2
            IPermB = IPerm
         End If

      End Do

      IPrint = IPrOld
      If(IPrint.ge.5) Write(6,*) 'MakStd:The best permutation is ',
     $IPermB      

      ExpR = ExpBst
      If(IPrint.ge.6)
     $Call Output(6,ExpR,'The smallest expresion',-1)

C      ExpR%IPowr(8) = 1

      Return
      End

