      Module Md1Opr
      Use ModMom
      Implicit None

      Type One_Operator
         Character*(2)                     ::  Title
         Type(MomExp)                      ::  Argument
         Integer, Dimension(2)             ::  Index
      End Type One_Operator 

      Interface Operator (.grth.)
         Module Procedure Greater_Than_Op
      End Interface

      Contains
C############################################################
      Function Greater_Than_Op(A,B)
         Implicit None
         Type(One_Operator),Intent(In)        :: A,B
         Logical                   :: Greater_Than_Op
         Logical Electron_Operator,Positron_Operator,Photon_Operator
         Logical Electron_Creation,Electron_Destruction
         Logical Positron_Creation,Positron_Destruction
         Logical Photon_Creation,Photon_Destruction

         Greater_Than_Op = .false.
         If(Electron_Operator(A).and.Positron_Operator(B)) then
            Greater_Than_Op = .true.
            Return
         Else If
     $   (Electron_Operator(A).and.Photon_Operator(B)) then
            Greater_Than_Op = .true.
            Return
         Else If
     $   (Positron_Operator(A).and.Photon_Operator(B)) then
            Greater_Than_Op = .true.
            Return
         Else If
     $   (Electron_Creation(A).and.Electron_Destruction(B)) then
            Greater_Than_Op = .true.
            Return
         Else If
     $   (Positron_Creation(A).and.Positron_Destruction(B)) then
            Greater_Than_Op = .true.
            Return
         Else If
     $   (Photon_Creation(A).and.Photon_Destruction(B)) then
            Greater_Than_Op = .true.
            Return
         Else If(A%Title.eq.B%Title) then
            If(A%Argument.grth.B%Argument) then
               Greater_Than_Op = .true.
               Return
            End If
         End If
      End Function Greater_Than_Op
C############################################################
      End Module Md1Opr
