      Function EnrSgn(Enrgy)
C     Returns ... 1  if Enrgy can be only positive
C             ... -1 if Enrgy can be only negative
C             ... 0  if Enrgy has undefined sign
C     Enrgy%Sign ... total sign in front of the energy
C     Enrgy%Energies(i)%Sign ... signs of individual energy terms

      Use ModEnr
      Implicit None
      Type(Energy) Enrgy
      Integer EnrSgn,i,NPls,NMin

      EnrSgn=0
      If(Enrgy%NumO.eq.1) then
         EnrSgn = Enrgy%Energies(1)%Sign*Enrgy%Sign
      Else If(Enrgy%NumO.eq.2) then
         If(Enrgy%Energies(1)%Sign.eq.1.and.
     $      Enrgy%Energies(2)%Sign.eq.1) then
            EnrSgn=Enrgy%Sign
         Else If(Enrgy%Energies(1)%Sign.eq.-1.and.
     $      Enrgy%Energies(2)%Sign.eq.-1) then
            EnrSgn=-Enrgy%Sign
         End If
      Else If(Enrgy%NumO.gt.2) then  
C        Count numbers of pluses and minuses
         NPls=0
         NMin=0

         Do i=1,Enrgy%NumO
            If(Enrgy%Energies(i)%Sign.eq.1) NPls=NPls+1
            If(Enrgy%Energies(i)%Sign.eq.-1) NMin=NMin+1
         End Do

         If(NPls.le.1) then
            EnrSgn = -Enrgy%Sign
         Else If(NMin.le.1) then
            EnrSgn = Enrgy%Sign
         End If
      End If

      Return
      End
