      Subroutine FrmPer(IPerm,NNum,Permut,ISign)
C     Form permutation
C       Input: 
C     Iperm(8) ... for each type of operator (A^,A_,B^,B_,C^,C_,U,V)
C                         holds permutation as integer, i.e. 132
C       Output:
C     Permut   ... position of each operator after permutation
C       Example:
C     Operator was A^(1)A^(2)A^(3)A_(1)U(1)V(1)V(2)
C     NNum  was   (3,1,0,0,0,0,1,2)
C     IPerm was   (321,1,0,0,0,0,1,21)
C     Permut is   (3,2,1,4,5,7,6)
C     Operator after permutation
C                 A^(3)A^(2)A^(1)A_(1)U(1)V(2)V(1)
      Use ModXpr
      Implicit None
      Dimension IPerm(8),NNum(8),Permut(nmaxOp+nmaxUV)
      Integer, Dimension(8):: ICiphr
      Logical Parity
      Integer ILast,ILast2,IPerm,NNum,Permut,i,j,ISign

      ILast=0
      ILast2 = 0
      ISign=0
C     Form vector of permutations
      Do i=1,8
         If(NNum(i).eq.0) Cycle
         If(NNum(i).eq.1) then
            ILast=ILast+1
            ILast2=ILast
            Permut(ILast) = ILast2
         Else If(NNum(i).gt.1) then
C           Decipher i
            Call Deciph(IPerm(i),NNum(i),ICiphr)
            If(.not.Parity(ICiphr,NNum(i)).and.i.le.4) ISign=ISign+2
            Do j=1,NNum(i)
               ILast=ILast+1
               Permut(ILast) = ICiphr(j) + ILast2
            End Do
            ILast2=ILast
         End If
      End Do
      Return
      End
