      Module Md1UVE
      Use ModMom
         Implicit None

      Type One_UVFunction
         Character                            ::  Title
         Type(MomExp)                         ::  Argument
         Integer, Dimension(2)                ::  Index
      End Type One_UVFunction

      Type One_Gamma
         Character                            ::  Title
         Character                            ::  Label
         Integer, Dimension(2)                ::  Index
      End Type One_Gamma

      Interface Operator (.grth.)
         Module Procedure Greater_Than_Gam , Greater_Than_OneUV
      End Interface

      Contains
C############################################################
      Function Greater_Than_OneUV(A,B)
         Implicit None
         Type(One_UVFunction),Intent(In)      :: A,B
         Logical Greater_Than_OneUV

         Greater_Than_OneUV = .false.
         If(A%Title.eq.'#'.or.B%Title.eq.'#') Return
         If(A%Title.eq.'U'.and.B%Title.eq.'V') then
            Greater_Than_OneUV=.true.
            Return
         Else If(A%Title.eq.B%Title) then
            If(A%Argument .grth. B%Argument) then
               Greater_Than_OneUV=.true.
               Return               
            End If
         End If
      End Function Greater_Than_OneUV
C############################################################
      Function Greater_Than_Gam(A,B)
         Implicit None
         Type(One_Gamma),Intent(In)     :: A,B
         Logical Greater_Than_Gam

         Greater_Than_Gam= .false.
         If(A%Index(1).gt.B%Index(1)) then
            Greater_Than_Gam= .true.
            Return
         Else If(A%Index(1).eq.B%Index(1)) then
            If(A%Index(2).gt.B%Index(2)) then
               Greater_Than_Gam= .true.
               Return
            End If
         End If
      End Function Greater_Than_Gam
C###############################################################
      End Module Md1UVE     
