      Module ModDNT
      Use ModLet
      Use ModMom
      Implicit None

      Type(List),Save :: DoNotT

      Contains
C####################################################################
      Function VarOKToChange(Momen)
C     Find momentum in momexp Momen that doesn't belong to DoNotT
C     and thus can be changed
      Type(MomExp) Momen
      Type(Momentum) VarOKToChange
      Integer i,ii

      Do i=1,Momen%Length
C        First try to change momenta with higher character
         ii = Momen%Length-i+1
         If(Index(DoNotT%Body(:DoNotT%Length),
     $   Momen%Momenta(ii)%Char).ne.0) Cycle

         VarOKToChange = Momen%Momenta(ii)
         Return
      End Do
      Write(6,*) 'Warning!!! All momenta cannot be touched!'
      End Function VarOKToChange
C####################################################################
      End Module ModDNT
