      Subroutine PermAp(ig,MMin,MMax,NNum,Exp2,Cyc,IPerm)

C      Apply permutation number i to term Exp2
C      Cyc ... 0 permutation has been applied
C          ... 1 permutation has been skipped
      Use ModXpr
      Implicit None
      Type(Expression)          :: Exp2
      Type(Energy) Mass
      Integer,Dimension(8) :: IPerm,MMin,MMax,NNum
      Integer,Dimension(nmaxOp+nmaxUV) :: Permt
      Logical Forbid
      Integer IType,ISign,Cyc,ig
      COMMON /Type/ IType
      Integer IPrint
      COMMON /Print/ IPrint
 
      Cyc=1
      Call GenPer(ig,MMin,MMax,NNum,IPerm)

C     In the future arrange UV terms in
C     increasing order (terms with smaller
C     argument first). Then trivial permutation
C     may not be done. First (smaller) argument
C     will be +g* and will not be affected by
C     Standr

      Call FrmPer(IPerm,NNum,Permt,ISign)
      If(Forbid(Permt,Exp2%Oper,Exp2%UVE)) Return

      Cyc=0
      If(IPrint.ge.9) Write(6,*) 'MakStd:Try permutation',IPerm
C     Apply permutation(i,j,k,l,m,n)to OperR

      If(IPrint.ge.9) Call Output(6,Exp2,'MakStd:Before PermAp',-1)
      Exp2%IPowr(3)=Exp2%IPowr(3) + ISign
      Call ApplyP(Permt,Exp2)
      Call Standr(Exp2)
      If(IPrint.ge.9) Call Output(6,Exp2,'After ApplyP',-1)

      Return
      End
