      Subroutine Produc(ICurr,Exp1,Exp2,ExpR)
C
C     This program calculates product of two expressions Exp1 and
C     Exp2, put resulting normally ordered expressions in array
C     ExpR. Returns ICurr as the last filled position in ExpR

      Use ModXpr
      Implicit None
      Type(Expression)                     :: Exp1, Exp2
      Type(Expression), Dimension(NumExp)  :: ExpR

C     Internal arrays
      Type(Expression)                     :: Exp3
      Logical ChkTmp
      Integer IStaCr,m,ICurr
      Integer IPrint
      COMMON /Print/ IPrint

      If(.not.ChkTmp(Exp1,Exp2,ExpR,ICurr+1)) Return
      If(IPrint.ge.9) Call Output(6,Exp1,'Term1',-1)
      If(IPrint.ge.9) Call Output(6,Exp2,'Term2',-1)

      Exp3 = Exp1*Exp2

C     XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
      IStaCr=ICurr+1

C     ICurr marks the first empty element in 'R' arrays

C      If(IPrint.ge.9) Call Output(6,Exp3,'After product',-1)

      Call Normal(ICurr,Exp3,ExpR)

C     At this point ICurr is position at which last operator 
C     has been written in 'R' arrays

      If(IPrint.ge.10) then
         Write(6,*) 'IStaCr,ICurr= ',IStaCr,ICurr
         Do m=IStaCr,ICurr
            Call Output(6,ExpR(m),'Added to OperR',m)
         End Do
      End If

      Call Finalz(ICurr,IStaCr,ExpR) 

      Return
      End

