      Function Summa(Exp1,Exp2)
C     Attempt to make a sum of two expressions
      Use ModXpr
      Use ModUVE
      USE ModExp
      Implicit None

      Type(Expression) Exp1,Exp2,Exp
      Logical Summa,TrySum
      Integer,Dimension(8) :: IPerm,IPermB,MMin,MMax,NNum
      Integer i,NumTot,IPrOld
      Integer Cyc 
      Integer IPrint
      COMMON /Print/ IPrint

      Summa=.false.
      If(Exp1%IPowr(1).ne.Exp2%IPowr(1)) Return
      If(Exp1%IPowr(2).ne.Exp2%IPowr(2)) Return
C     Make all possible permutations in term Exp2 and try to 
C     form a sum with Exp1

      Call PreNum(Exp2%Oper,Exp2%UVE,MMin,MMax,IPermB,NNum,NumTot)

      If(IPrint.ge.9) Write(6,*)'MakStd:MMin=',MMin
      If(IPrint.ge.9) Write(6,*)'MakStd:MMax=',MMax
C     Try all permutations and find one that summation of
C     terms Exp1 and Exp2

      If(IPrint.ge.9) 
     $Call Output(6,Exp1,'MakStd:Term Exp1 Before permutations',-1)
      If(IPrint.ge.9) 
     $Call Output(6,Exp2,'MakStd:Term Exp2 Before permutations',-1)

      IPrOld = IPrint
      IPrint = -1
      Do i=1,NumTot

         Exp = Exp2
         Call  PermAp(i,MMin,MMax,NNum,Exp,Cyc,IPerm)
         If(Cyc.eq.1) Cycle
         If(IPrint.ge.10) Call Output(6,Exp,'Summa :After  PermAp',-1)
C        We can only allow permutations that do not change UVE and
C        Exponent

         If((Exp%UVE.equal.Exp2%UVE).and.
     $   (Exp%Exponent.equal.Exp2%Exponent)) then

            Summa=TrySum(Exp1,Exp)
            If(Summa) then
C              We succesfully added term Exp2 to Exp1
               If(Exp1%IPowr(1).ne.0)
     $         Call Order_Bracket(Exp1%Denominator,Exp1%IPowr)
               If(IPrint.ge.5) then
                  Write(6,*)'Exp1 and Exp2 make sum after permut ',IPerm
                  Call Output(6,Exp1,' ',-1)
               End If
               Return
            End If
         End If
      End Do
      IPrint = IPrOld

      Return
      End
